//=============================================================================
//
//
//
//
//
//=============================================================================
#ifndef			__SOYUZ_CAPSULE_H
#define			__SOYUZ_CAPSULE_H

class soyuz_capsule: public VESSEL2
{
public:
	soyuz_capsule(OBJHANDLE, int);
	~soyuz_capsule(){};

	void clbkSetClassCaps(FILEHANDLE);
	void clbkLoadStateEx(FILEHANDLE scn, void *status);
	void clbkSaveState(FILEHANDLE scn);
	void clbkPostStep(double, double, double);
	void clbkVisualCreated(VISHANDLE, int);
	void clbkVisualDestroyed(VISHANDLE, int);
	int  clbkConsumeDirectKey(char *keystate);
	int  clbkConsumeBufferedKey(DWORD key, bool down, char *kstate);

private:
	VISHANDLE			vis;
	MESHHANDLE			hsoyuz_capsule, hDoorMesh, hMainShute, hBrakeShute;
	ATTACHMENTHANDLE	hReentryShield, hShuteDoor;
	THRUSTER_HANDLE		th_sle[4];
	THGROUP_HANDLE		thg_main;
	PROPELLANT_HANDLE	ph_sle;
	PARTICLESTREAMSPEC	psc, psc1;
	AIRFOILHANDLE		hAirfoilV, hAirfoilH;
	MESHGROUP_TRANSFORM	mt01;

	char				MeshName[255];
	char				DoorMeshName[255];
	char				MainShuteName[255];
	char				BrakeShuteName[255];
	
	int					Far;
	int					MeshCount;
	int					ShuteDoorOpen;
	int					BrakeShute;
	int					BrakeShuteSep;
	int					BrakeShuteMeshIndex;
	int					MainShute;
	int					MainShuteSep;
	int					MainShuteMeshIndex;
	int					Separated;

	double				F01, F02;
	double				BrakeShuteDrag;
	double				MainShuteDrag;
	double				PhiBS, PsiBS;
	double				PhiMS, PsiMS;

	VECTOR3				SLE01_DIR, SLE02_DIR, SLE03_DIR, SLE04_DIR;
	VECTOR3				Brake_DIR;
	VECTOR3				Main_DIR;

	void CommandExec(int);
	void BrakeShuteMeshRotate(double psi, double phi, int n);
	void MainShuteMeshRotate(double psi, double phi, int n);
	void LandingProgram(double t, double dt);
};

#endif